type identifier = string
	  
datatype expression =
    CExp of int
  | IExp of identifier
  | Cond of condition * expression * expression
  | Appl of identifier * expression list
  | Let  of declaration list * expression

and declaration =
    Fun of identifier * identifier list * expression
  | Val of identifier * expression

and condition = 
    Equal  of expression * expression
  | Less   of expression * expression
  | LessEq of expression * expression
    
